
/*******************************************************************************
*
* File check4.c
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Generation of partitions.
*
*******************************************************************************/

#define MAIN_PROGRAM

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "utils.h"
#include "permutations.h"


static void chk_part(int n,int s,int *i)
{
   int k,sm;

   sm=0;

   for (k=0;k<n;k++)
      sm+=i[k];

   error(sm!=s,1,"chk_part [check4.c]","Incorrect partition sum");

   for (k=1;k<n;k++)
   {
      if (i[k-1]<i[k])
         error(1,1,"chk_part [check4.c]","Improperly ordered partition");
   }
}


int main(void)
{
   int k,n,s,*i;
   long ni,nim;

   printf("\n");
   printf("Generation of partitions\n");
   printf("------------------------\n\n");

   while(1)
   {
      printf("Specify no of integers n and number s to be partitioned: ");
      (void)scanf("%d %d",&n,&s);

      ni=0L;
      nim=init_partition(n,s);

      i=malloc(n*sizeof(*i));
      error(i==NULL,1,"main [check4.c]",
            "Unable to allocate auxiliary arrays");

      printf("\n\n");
      printf("Partitions:\n");
      printf("Total number of partitions = %ld\n",nim);

      while (ni<nim)
      {
         ni=next_partition(i);
         chk_part(n,s,i);

         printf("ni = %3ld:  ",ni);

         for (k=0;k<n;k++)
         {
               if (k==0)
                  printf("%d",i[k]);
               else
                  printf(",%d",i[k]);
         }

         printf("\n");
      }

      printf("\n");
      printf("Wrapping around:\n");
      ni=0L;

      while (ni<(1L+nim/2L))
      {
         ni=next_partition(i);

         printf("ni = %3ld:  ",ni);

         for (k=0;k<n;k++)
         {
               if (k==0)
                  printf("%d",i[k]);
               else
                  printf(",%d",i[k]);
         }

         printf("\n");
      }

      printf("...\n\n");
      stop_partition();
   }

   exit(0);
}
