
/*******************************************************************************
*
* File dmlist.h
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef DIAGRAMS_H
#include "diagrams.h"
#endif

#ifndef TREES_H
#include "trees.h"
#endif

#ifndef DMLIST_H
#define DMLIST_H

typedef struct
{
   int n,nmax,tid;
   int **rka;
   cnum_t **cna;
   diagram_t **dma;
} dlist_t;

typedef struct
{
   int n,nmax;
   cnum_t **cna;
   ltree_t **lta;
} tlist_t;

/* AATREE_C */
extern int init_aatree(void *context,
                       int (*rank)(int oid1,int oid2,void *context),
                       int (*is_equal)(int oid1,int oid2,void *context));
extern int insert_aatree(int oid,int tid);
extern int search_aatree(int oid,int tid,int *ifail);
extern void free_aatree(int tid);
extern int check_aatree(int tid);

/* DMLIST_C */
extern dlist_t *alloc_dlist(int nmax,int flag);
extern void free_dlist(dlist_t *dl);
extern void deep_free_dlist(dlist_t *dl);
extern void add_dgm(diagram_t *dm,dlist_t *dl);
extern int insert_dgm(diagram_t *dm,int *rk,dlist_t *dl);
extern int insert_copy(diagram_t *dm,int *rk,dlist_t *dl);
extern int search_dgm(diagram_t *dm,int *rk,dlist_t *dl);

/* TDLIST_C */
extern tlist_t *alloc_tlist(int nmax);
extern void free_tlist(tlist_t *tl);
extern void deep_free_tlist(tlist_t *tl);
extern void add_ltd(ltree_t *td,tlist_t *tl);

#endif
