
/*******************************************************************************
*
* File trees.h
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef TREES_H
#define TREES_H

#ifndef DIAGRAMS_H
#include "diagrams.h"
#endif

typedef struct
{
   int nv;
   int (*v)[2];
   ltype_t *l;
} branch_t;

typedef struct
{
   int rv,nl;
   line_t *l;
   diagram_t *dm;
} ltree_t;

#ifndef DMLIST_H
#include "dmlist.h"
#endif

/* BRANCH_C */
extern branch_t *alloc_branch(int nv);
extern void free_branch(branch_t *br);
extern int branches(theory_t th,int order);
extern int get_nv(theory_t th,int ibr);
extern int get_order(theory_t th,int ibr);
extern void get_branch(theory_t th,int ibr,branch_t *br);
extern int find_branch(theory_t th,branch_t *br);
extern int inverse_branch(theory_t th,int ibr);
extern void branch2dgm(branch_t *br,diagram_t *dm);

/* LTREE_C */
extern ltree_t *alloc_ltd(int nl);
extern void free_ltd(ltree_t *td);
extern void copy_ltd(ltree_t *td1,ltree_t *td2);
extern void ltd2dgm(ltree_t *td,diagram_t *dm);

/* LTREE_GEN_C */
extern int ltrees(theory_t th,int order);
extern int nlp_max(theory_t th,int order);
extern int no_of_ltrees(theory_t th,int order,int nlp);
extern tlist_t *select_ltrees(theory_t th,int order,int nlp);
extern void set_root(theory_t th,int is);

/* TREE_GEN_C */
extern int trees(theory_t th,int order);
extern int nbr_max(theory_t th,int order);
extern int no_of_trees(theory_t th,int order,int nbr);
extern dlist_t *select_trees(theory_t th,int order,int nbr);
extern void tree_lines(theory_t th,int order,int *nlall,int *nevtx,int *neall);

#endif
